
#include "Manifolds/Multinomial/MNVariable.h"

/*Define the namespace*/
namespace ROPTLIB{

	MNVariable::MNVariable(integer n, integer m)
	{
		Element::Initialization(2, n, m);
	};

	MNVariable *MNVariable::ConstructEmpty(void) const
	{
		return new MNVariable(size[0], size[1]);
	};

	void MNVariable::RandInManifold(void)
	{
		integer n = size[0];
		integer m = size[1];
		NewMemoryOnWrite();
		/*temp is an n by m matrix*/
		for (integer i = 0; i < n; i++)
		{
			for (integer j = 0; j < m; j++)
			{
				Space[i + j * n] = genrandreal();
			}
		}
		realdp ss = 0;
		for (integer i = 0; i < n; i++)
		{
			ss = 0;
			for (integer j = 0; j < m; j++)
				ss += Space[i + j * n];

			for (integer j = 0; j < m; j++)
				Space[i + j * n] /= ss;
		}
	};
}; /*end of ROPTLIB namespace*/
