/*
This file defines the class of a point on the manifold Ob(n, num) / O_{n-1} = \{[X] | X \in Ob(n, num) \} where
[X] = \{X [Q, 0; 0, 1] | Q^T Q = I \}.

SmartSpace --> ProductElement --> ObliqueQVariable

---- WH
*/

#ifndef OBLIQUEQVARIABLE_H
#define OBLIQUEQVARIABLE_H

#include "Manifolds/ProductElement.h"
#include "Manifolds/Sphere/SphereVariable.h"

/*Define the namespace*/
namespace ROPTLIB{

	class ObliqueQVariable : public ProductElement{
	public:
		/*Construct an empty variable on the Oblique manifold with only size information.*/
		ObliqueQVariable(integer n, integer num);

		/*Destruct by deleting all variables*/
		virtual ~ObliqueQVariable();

		/*Create an object of ObliqueVariable with same size as this ObliqueVariable.*/
		virtual ObliqueQVariable *ConstructEmpty(void) const;

		/*Print this point on oblique as a matrix*/
		virtual void Print(const char *name = "", bool isonlymain = true) const;
	};
}; /*end of ROPTLIB namespace*/
#endif // end of OBLIQUEQVARIABLE_H
