/*
This file defines the class of a point on the tangent space of the manifold 
Ob(n, num) / O_{n-1} = \{[X] | X \in Ob(n, num) \} where
[X] = \{X [Q, 0; 0, 1] | Q^T Q = I \}.

SmartSpace --> ProductElement --> ObliqueQVector

---- WH
*/

#ifndef OBLIQUEQVECTOR_H
#define OBLIQUEQVECTOR_H

#include "Manifolds/ProductElement.h"
#include "Manifolds/Sphere/SphereVector.h"

/*Define the namespace*/
namespace ROPTLIB{

	class ObliqueQVector : public ProductElement{
	public:
		/*Construct an empty vector on the tangent space of Oblique manifold with only size information. */
		ObliqueQVector(integer n, integer num);

		/*Destruct by deleting all components*/
		virtual ~ObliqueQVector();

		/*Create an object of ObliqueVector with same size as this ObliqueVector.*/
		virtual ObliqueQVector *ConstructEmpty(void) const;

		/*Print this point on tangent space of oblique as a matrix*/
		virtual void Print(const char *name = "", bool isonlymain = true) const;
	};
}; /*end of ROPTLIB namespace*/
#endif // end of OBLIQUEVECTOR_H
