
#include "Manifolds/PreShapeCurves/PSCVariable.h"

/*Define the namespace*/
namespace ROPTLIB{
	PSCVariable::PSCVariable(integer r, integer c, integer n)
	{
		Element::Initialization(3, r, c, n);
	};

	PSCVariable *PSCVariable::ConstructEmpty(void) const
	{
		return new PSCVariable(size[0], size[1], size[2]);
	};

	void PSCVariable::RandInManifold(void)
	{
		Element::RandGaussian();
		printf("PSCVariable::RandInManifold(). TODO\n");
	};

	void PSCVariable::Generate(realdp *initial, realdp *end)
	{
		realdp *q1, *q2;
		realdp theta, tau, coeff;
		q1 = initial;
		q2 = end;
		NewMemoryOnWrite();   //???????????
		integer numP = size[0];
		integer dim = size[1];
		integer numC = size[2];
		integer NXD = numP*dim;
		realdp *temp = new realdp[numP*dim];

		//this->Print("before===============before");
    
		theta = std::acos(PreShapePathStraighten::InnerProd_Q(q1, q2, numP, dim));
    
		if (theta > 0.0001)
		{
			for (integer t = 0; t < numC; t++)
			{
				tau = static_cast<realdp> (t) / (numC - 1);
				for (integer i = 0; i < numP*dim; i++)
				{
					temp[i] = (std::sin((static_cast<realdp> (1)-tau)*theta)*q1[i] + std::sin(tau*theta)*q2[i]) / std::sin(theta);
				}
            
					//ForDebug::Print("temptemp======", temp, numP, dim);
					//ForDebug::Print("q1q1q1=======", q1, numP, dim);

					//ForDebug::Print("q2q2q2=======", q2, numP, dim);
	//            if (t == 10) {
	//                ForDebug::Print("Space==========", Space+t*numP*dim, numP, dim);
	//            }
				PreShapePathStraighten::Item_1(temp, numP, dim, Space+t*numP*dim);
	//            if (t == 10) {
	//                ForDebug::Print("Space==========", Space+t*numP*dim, numP, dim);
	//            }
				coeff = static_cast<realdp> (1) / std::sqrt(PreShapePathStraighten::InnerProd_Q(Space+t*numP*dim, Space+t*numP*dim, numP, dim));
				scal_(&NXD, &coeff, Space+t*numP*dim, &GLOBAL::IONE);
			}
		}
		else
		{
			for (integer t = 0; t < numC; t++)
			{
				copy_(&NXD, q1, &GLOBAL::IONE, Space+t*numP*dim, &GLOBAL::IONE);
			}
		}
    
		//this->Print("after===============after");
    
		delete[] temp;
	}
}; /*end of ROPTLIB namespace*/
