
seed = round(rand() * 1000000000);
seed = 777;
fprintf("seed1:%d\n", seed);
rng(seed);

n = 3000;
r = 4;
lambda = 2.5;
m = 40;

A = randn(m, n);
A = A - repmat(mean(A, 1), m, 1);
A = A ./ repmat(sqrt(sum(A .* A)), m, 1);
[U, S, V] = svd(A, 'econ');
PCAV = V(:, 1:r);
initx = PCAV;
tmp = A * PCAV; maxvar = sum(tmp(:) .* tmp(:));
Xinitial = PCAV;
maxiter = 200;
        
fprintf('ManPG-D\n');
[xopt, iter, fs1, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(1, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);

fprintf('ManPG\n');
[xopt, iter, fs2, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(2, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);

fprintf('ManPG-Ada-D\n');
[xopt, iter, fs3, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(3, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);

fprintf('ManPG-Ada\n');
[xopt, iter, fs4, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(4, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);

fprintf('AManPG-D\n');
[xopt, iter, fs5, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(5, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);

fprintf('AManPG\n');
[xopt, iter, fs6, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(6, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);


figure(2);clf;
set(0,'defaultaxesfontsize',15, ...
   'defaultaxeslinewidth',0.7, ...
   'defaultlinelinewidth',.8,'defaultpatchlinewidth',0.8);
set(0,'defaultlinemarkersize',10)
shapes = {'*', 'v', '^', '+', 'o', 'x'};
subplot(1, 3, 1);
plot(1:5:length(fs1), fs1(1:5:end), ['-', shapes{1}]);hold on
plot(1:5:length(fs2), fs2(1:5:end), ['-', shapes{2}]);hold on
plot(1:5:length(fs3), fs3(1:5:end), ['-', shapes{3}]);hold on
plot(1:5:length(fs4), fs4(1:5:end), ['-', shapes{4}]);hold on
plot(1:5:length(fs5), fs5(1:5:end), ['-', shapes{5}]);hold on
plot(1:5:length(fs6), fs6(1:5:end), ['-', shapes{6}]);hold on
xlabel('iteration');
ylabel('F(X)');
ylim([-13, -3]);
xlim([0, maxiter]);
legend('ManPG-D', 'ManPG', 'ManPG-Ada-D','ManPG-Ada', 'AManPG-D', 'AManPG');
title('Random data')

dat = importdata('dataBCT.txt');
D = (dat.data)';
[m, n] = size(D);
A = D - ones(size(D,1),1)*mean(D, 1);
tmp = sqrt(sum(A .* A));
A = A ./ repmat(tmp, m, 1);
lambda = 6;
r = 4;

[U, S, V] = svd(A, 'econ');
PCAV = V(:, 1:r);
initx = PCAV;
tmp = A * PCAV; maxvar = sum(tmp(:) .* tmp(:));
Xinitial = PCAV;
maxiter = 200;
        
fprintf('ManPG-D\n');
[xopt, iter, fs1, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(1, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);

fprintf('ManPG\n');
[xopt, iter, fs2, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(2, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);

fprintf('ManPG-Ada-D\n');
[xopt, iter, fs3, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(3, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);

fprintf('ManPG-Ada\n');
[xopt, iter, fs4, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(4, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);

fprintf('AManPG-D\n');
[xopt, iter, fs5, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(5, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);

fprintf('AManPG\n');
[xopt, iter, fs6, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(6, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);


figure(2);
subplot(1, 3, 2);
plot(1:5:length(fs1), fs1(1:5:end), ['-', shapes{1}]);hold on
plot(1:5:length(fs2), fs2(1:5:end), ['-', shapes{2}]);hold on
plot(1:5:length(fs3), fs3(1:5:end), ['-', shapes{3}]);hold on
plot(1:5:length(fs4), fs4(1:5:end), ['-', shapes{4}]);hold on
plot(1:5:length(fs5), fs5(1:5:end), ['-', shapes{5}]);hold on
plot(1:5:length(fs6), fs6(1:5:end), ['-', shapes{6}]);hold on
xlabel('iteration');
ylabel('F(X)');
ylim([-7750, -7500]);
xlim([0, maxiter]);
legend('ManPG-D', 'ManPG', 'ManPG-Ada-D','ManPG-Ada', 'AManPG-D', 'AManPG'); %'RPG-Ada', 
title('DNA methylation data')

m = 400; n = 4000; r = 5;
lambda = 1.5;
noiselevel = 0.5;
t = linspace(0, 1, n);

pc1 = max(0, ((t - 0.6)> 0) & (0.8 - t > 0))*0.5;
pc2 = max(0, ((t - 0.2)> 0) & (0.4 - t > 0))*0.5;
pc3 = 0.8*exp(-(t - 0.5).^2/5e-3);
pc4 = 0.4*exp(-(t - 0.15).^2/1e-3) + 0.4*exp(-(t - 0.85).^2/1e-3);
pc5 = 0.4*exp(-(t - 0.05).^2/1e-3) - 0.4*exp(-(t - 0.95).^2/1e-3);
PC = [pc1; pc2; pc3; pc4; pc5];
truesparsity = sum(sum(PC~=0)) / length(PC(:))
A = [ones(m/5,1)*pc1 + randn(m/5,n) * noiselevel; ...
     ones(m/5,1)*pc2 + randn(m/5,n) * noiselevel; ...
     ones(m/5,1)*pc3 + randn(m/5,n) * noiselevel; ...
     ones(m/5,1)*pc4 + randn(m/5,n) * noiselevel; ...
     ones(m/5,1)*pc5 + randn(m/5,n) * noiselevel];
tmp = sqrt(sum(A .* A));
A = A ./ repmat(tmp, m, 1);


[U, S, V] = svd(A, 'econ');
PCAV = V(:, 1:r);
initx = PCAV;
tmp = A * PCAV; maxvar = sum(tmp(:) .* tmp(:));
Xinitial = PCAV;
maxiter = 200;
        
fprintf('ManPG-D\n');
[xopt, iter, fs1, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(1, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);

fprintf('ManPG\n');
[xopt, iter, fs2, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(2, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);

fprintf('ManPG-Ada-D\n');
[xopt, iter, fs3, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(3, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);

fprintf('ManPG-Ada\n');
[xopt, iter, fs4, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(4, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);

fprintf('AManPG-D\n');
[xopt, iter, fs5, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(5, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);

fprintf('AManPG\n');
[xopt, iter, fs6, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(6, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);

figure(2);
subplot(1, 3, 3);
plot(1:5:length(fs1), fs1(1:5:end), ['-', shapes{1}]);hold on
plot(1:5:length(fs2), fs2(1:5:end), ['-', shapes{2}]);hold on
plot(1:5:length(fs3), fs3(1:5:end), ['-', shapes{3}]);hold on
plot(1:5:length(fs4), fs4(1:5:end), ['-', shapes{4}]);hold on
plot(1:5:length(fs5), fs5(1:5:end), ['-', shapes{5}]);hold on
plot(1:5:length(fs6), fs6(1:5:end), ['-', shapes{6}]);hold on
xlabel('iteration');
ylabel('F(X)');
ylim([-305, -230]);
xlim([0, 100]);
legend('ManPG-D', 'ManPG', 'ManPG-Ada-D','ManPG-Ada', 'AManPG-D', 'AManPG'); %'RPG-Ada', 
title('Synthetic data')


% fout = fopen('Compare_PGall_Ob_tab.txt','w');
% for i = 1 : size(avetab, 1)
%     for j = 1 : size(avetab, 2)
%         if(j == 1 )
%             fprintf(fout, '%d & ', round(avetab(i, j)));
%         elseif(j == size(avetab, 2))
%             fprintf(fout, '%1.2f \\\\', avetab(i, j));
%         elseif(j == 3 || j == 4)
%             fprintf(fout, '$%s$ & ', outputfloat(avetab(i, j)));
%         else
%             fprintf(fout, '%1.2f & ', avetab(i, j));
%         end
%     end
%     fprintf(fout,'\n');
% end
% fclose(fout);


function [xopt, iter, fsall, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(method, A, Xinitial, n, p, m, tolsq, maxiter, lambda, ftol);
    tol = sqrt(tolsq);
    if(norm(sum(A .* A) - ones(1, n)) < 1e-5) % if the columns of A are normalized
        LengthW = p;
    else
        LengthW = n * p;
    end
    %LengthW  %1     : use Lipschitz constant,        
              %n * r : Diagonal matrix inspired from Riemannian Hessian
              %r     : If matrix A is normalized, then the diagonal matrix can be simplified
    
    switch method
        case 1
            SolverParams.method = 'RPG'; % RPG D
            SolverParams.RPGVariant = 0;
            SolverParams.LengthW = LengthW;
        case 2
            SolverParams.method = 'RPG'; % RPG
            SolverParams.RPGVariant = 0;
            SolverParams.LengthW = 1;
        case 3
            SolverParams.method = 'RPG'; % RPG D ada
            SolverParams.RPGVariant = 1;
            SolverParams.LengthW = LengthW;
        case 4
            SolverParams.method = 'RPG'; % RPG ada
            SolverParams.RPGVariant = 1;
            SolverParams.LengthW = 1;
        case 5
            SolverParams.method = 'ARPG'; % ARPG D
            SolverParams.RPGVariant = 0;
            SolverParams.LengthW = LengthW;
%             SolverParams.SGIterGap = inf;
        case 6
            SolverParams.method = 'ARPG'; % ARPG
            SolverParams.RPGVariant = 0;
            SolverParams.LengthW = 1;
%             SolverParams.SGIterGap = 100000;
    end

    SolverParams.IsCheckParams = 1;
%     SolverParams.RPGVariant = 0; %0: RPG without adaptive stepsize, 1: RPG with adaptive stepsize
    SolverParams.OutputGap = 2;
    SolverParams.Max_Iteration = maxiter;
    SolverParams.DEBUG = 1;
    SolverParams.Tolerance = tol;
    [xopt, fs, Ds, gfgf0, iter, nf, ng, nR, nV, nVp, nH, comtime, fsall, Dsall, times] = ...
        TestStieSPCA(A, lambda, Xinitial, SolverParams);
    
    xopt.main(abs(xopt.main) < 1e-5) = 0;
    sparsity = sum(sum(abs(xopt.main) < 1e-5)) / (n * p);
    xopt = reshape(xopt.main, n, p);
    % adjusted variance
    [Q, R] = qr(A * xopt, 0);
    avar = trace(R * R);
end

function str = outputfloat(x)
    if(x <= 0)
        sn = '-';
        x = abs(x);
    else
        sn = '';
    end
    p = log(x)/log(10);
    p = - ceil(-p);
    x = round(x * 10^(-p) * 100);
    x = x / 100;
    strx = sprintf('%3.2f', x);
    if(p ~= 0)
        str = [sn strx '_{' num2str(p) '}'];
    else
        str = [sn strx];
    end
end
