
clear;

% % for random data
% dataset = 1;
% numrand = 20;
% lambdas = [2, 2.5, 3];
% r = 4;

% % for gene data
% dataset = 2;
% numrand = 1;
% lambdas = [2, 6, 10];
% r = 4;

% for artificial data
dataset = 3;
numrand = 1;%20;
lambdas = 1.5;%[1, 1.5, 2];
r = 5;

timeupper = 0.001;

tab = zeros(6, 7, length(lambdas), numrand);
for i = 1 : numrand
    rng(i*10);
    for j = 1 : length(lambdas)

        lambda = lambdas(j);
        [i, lambda]
        
        if(dataset == 1)
            n = 3000;
            m = 40;
            A = randn(m, n);
            A = A - repmat(mean(A, 1), m, 1);
            A = A ./ repmat(sqrt(sum(A .* A)), m, 1);
        elseif(dataset == 2)
            dat = importdata('dataBCT.txt');
            D = (dat.data)';
            [m, n] = size(D);
            A = D - ones(size(D,1),1)*mean(D, 1);
            tmp = sqrt(sum(A .* A));
            A = A ./ repmat(tmp, m, 1);
        elseif(dataset == 3)
            
            m = 400; n = 4000;
            noiselevel = 0.5;
            t = linspace(0, 1, n);
            
            pc1 = max(0, ((t - 0.6)> 0) & (0.8 - t > 0))*0.5;
            pc2 = max(0, ((t - 0.2)> 0) & (0.4 - t > 0))*0.5;
            pc3 = 0.8*exp(-(t - 0.5).^2/5e-3);
            pc4 = 0.4*exp(-(t - 0.15).^2/1e-3) + 0.4*exp(-(t - 0.85).^2/1e-3);
            pc5 = 0.4*exp(-(t - 0.05).^2/1e-3) - 0.4*exp(-(t - 0.95).^2/1e-3);
            PC = [pc1; pc2; pc3; pc4; pc5];
                        
            truesparsity = sum(sum(PC~=0)) / length(PC(:))
            A = [ones(m/5,1)*pc1 + randn(m/5,n) * noiselevel; ...
                 ones(m/5,1)*pc2 + randn(m/5,n) * noiselevel; ...
                 ones(m/5,1)*pc3 + randn(m/5,n) * noiselevel; ...
                 ones(m/5,1)*pc4 + randn(m/5,n) * noiselevel; ...
                 ones(m/5,1)*pc5 + randn(m/5,n) * noiselevel];
            tmp = sqrt(sum(A .* A));
            A = A ./ repmat(tmp, m, 1);
        else
            fprintf('no such dataset\n');
            return;
        end
        
        [U, S, V] = svd(A, 'econ');
        PCAV = V(:, 1:r);
        initx = PCAV;
        tmp = A * PCAV; maxvar = sum(tmp(:) .* tmp(:));
        Xinitial = PCAV;
        maxiter = 10000;

        fprintf('ManPN Diag(Hessian)\n');
        totaltime = 0; times = 0;
        while(totaltime < timeupper)
            [xopt, iter, fs1, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(1, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);
            totaltime = totaltime + comtime;
            times = times + 1;
        end
        comtime = totaltime / times;
        tab(1, 1, j, i) = lambda;
        tab(1, 2, j, i) = iter;
        tab(1, 3, j, i) = comtime;
        tab(1, 4, j, i) = fs1(end);
        tab(1, 5, j, i) = Ds(end);
        tab(1, 6, j, i) = sparsity;
        tab(1, 7, j, i) = avar / maxvar;
        [comtime, sparsity]

        fprintf('ManPG\n');
        totaltime = 0; times = 0;
        while(totaltime < timeupper)
            [xopt, iter, fs1, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(2, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);
            totaltime = totaltime + comtime;
            times = times + 1;
        end
        comtime = totaltime / times;
        tab(2, 1, j, i) = lambda;
        tab(2, 2, j, i) = iter;
        tab(2, 3, j, i) = comtime;
        tab(2, 4, j, i) = fs1(end);
        tab(2, 5, j, i) = Ds(end);
        tab(2, 6, j, i) = sparsity;
        tab(2, 7, j, i) = avar / maxvar;
        [comtime, sparsity]
        
        fprintf('ManPN_ada Diag(Hessian)\n');
        totaltime = 0; times = 0;
        while(totaltime < timeupper)
            [xopt, iter, fs1, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(3, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);
            totaltime = totaltime + comtime;
            times = times + 1;
        end
        comtime = totaltime / times;
        tab(3, 1, j, i) = lambda;
        tab(3, 2, j, i) = iter;
        tab(3, 3, j, i) = comtime;
        tab(3, 4, j, i) = fs1(end);
        tab(3, 5, j, i) = Ds(end);
        tab(3, 6, j, i) = sparsity;
        tab(3, 7, j, i) = avar / maxvar;
        [comtime, sparsity]

        fprintf('ManPG_ada\n');
        totaltime = 0; times = 0;
        while(totaltime < timeupper)
            [xopt, iter, fs1, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(4, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);
            totaltime = totaltime + comtime;
            times = times + 1;
        end
        comtime = totaltime / times;
        tab(4, 1, j, i) = lambda;
        tab(4, 2, j, i) = iter;
        tab(4, 3, j, i) = comtime;
        tab(4, 4, j, i) = fs1(end);
        tab(4, 5, j, i) = Ds(end);
        tab(4, 6, j, i) = sparsity;
        tab(4, 7, j, i) = avar / maxvar;
        [comtime, sparsity]

        fprintf('AManPN Diag(Hessian)\n');
        totaltime = 0; times = 0;
        while(totaltime < timeupper)
            [xopt, iter, fs1, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(5, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);
            totaltime = totaltime + comtime;
            times = times + 1;
        end
        comtime = totaltime / times;
        tab(5, 1, j, i) = lambda;
        tab(5, 2, j, i) = iter;
        tab(5, 3, j, i) = comtime;
        tab(5, 4, j, i) = fs1(end);
        tab(5, 5, j, i) = Ds(end);
        tab(5, 6, j, i) = sparsity;
        tab(5, 7, j, i) = avar / maxvar;
        [comtime, sparsity]

        fprintf('AManPG\n');
        totaltime = 0; times = 0;
        while(totaltime < timeupper)
            [xopt, iter, fs1, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(6, A, Xinitial, n, r, m, 1e-10*n*r, maxiter, lambda, -inf); %(Xinitial, A, lambda, Lu, tol, maxiter, -inf);
            totaltime = totaltime + comtime;
            times = times + 1;
        end
        comtime = totaltime / times;
        tab(6, 1, j, i) = lambda;
        tab(6, 2, j, i) = iter;
        tab(6, 3, j, i) = comtime;
        tab(6, 4, j, i) = fs1(end);
        tab(6, 5, j, i) = Ds(end);
        tab(6, 6, j, i) = sparsity;
        tab(6, 7, j, i) = avar / maxvar;
        [comtime, sparsity]
    end
end

figure(100); clf
set(0,'defaultaxesfontsize',15, ...
   'defaultaxeslinewidth',0.7, ...
   'defaultlinelinewidth',2,'defaultpatchlinewidth',0.8);
set(0,'defaultlinemarkersize',10)
plot(PC');
title('Principal Components');
legend('Principal component 1', 'Principal component 2', 'Principal component 3', 'Principal component 4', 'Principal component 5')

figure(1); clf
set(0,'defaultaxesfontsize',15, ...
   'defaultaxeslinewidth',0.7, ...
   'defaultlinelinewidth',.8,'defaultpatchlinewidth',0.8);
set(0,'defaultlinemarkersize',10)
subplot(131)
plot(A');
title('Noisy data');
%legend('Principal component 1', 'Principal component 2', 'Principal component 3', 'Principal component 4', 'Principal component 5')

PCAVP = zeros(size(PCAV));
xoptP = zeros(size(xopt));
for i = 1 : r
    minv = 100000;
    minidx = 0;
    for j = 1 : r
        if(norm(PC(i, :) - xopt(:, j)') > norm(PC(i, :) + xopt(:, j)'))
            xopt(:, j) = -xopt(:, j);
            PCAV(:, j) = -PCAV(:, j);
        end
        
        if(minv > norm(PC(i, :) - xopt(:, j)'))
            minv = norm(PC(i, :) - xopt(:, j)');
            minidx = j;
        end
    end
    minidx
    PCAVP(:, i) = PCAV(:, minidx);
    xoptP(:, i) = xopt(:, minidx);
end

subplot(132)
plot(PCAVP);
title('PCA');
%legend('Principal component 1', 'Principal component 2', 'Principal component 3', 'Principal component 4', 'Principal component 5')

subplot(133);
plot(xoptP)
title('SPCA');
%legend('Principal component 1', 'Principal component 2', 'Principal component 3', 'Principal component 4', 'Principal component 5')
return;

dlmwrite('CompareLambdas_all.txt', tab);

avetab2 = mean(tab, 4);
avetab = [];
for i = 1 : size(avetab2, 3)
    avetab = [avetab; avetab2(:, :, i)];
end

size(avetab)

fout = fopen('CompareLambdas_tab.txt','w');
for i = 1 : size(avetab, 1)
    for j = 1 : size(avetab, 2)
        if(j == 2)
            fprintf(fout, '%d & ', round(avetab(i, j)));
        elseif(j == 1)
            fprintf(fout, '%1.1f & ', avetab(i, j));
        elseif(j == size(avetab, 2))
            fprintf(fout, '%1.2f \\\\', avetab(i, j));
        elseif(j == 4 || j == 5)
            fprintf(fout, '$%s$ & ', outputfloat(avetab(i, j)));
        else
            fprintf(fout, '%1.2f & ', avetab(i, j));
        end
    end
    fprintf(fout,'\n');
end
fclose(fout);

function [xopt, iter, fs, Ds, sparsity, comtime, avar] = driver_ManPG_invariants(method, A, Xinitial, n, p, m, tolsq, maxiter, lambda, ftol);
    tol = sqrt(tolsq);
    if(norm(sum(A .* A) - ones(1, n)) < 1e-5) % if the columns of A are normalized
        LengthW = p;
    else
        LengthW = n * p;
    end
    %LengthW  %1     : use Lipschitz constant,        
              %n * r : Diagonal matrix inspired from Riemannian Hessian
              %r     : If matrix A is normalized, then the diagonal matrix can be simplified
    
    switch method
        case 1
            SolverParams.method = 'RPG'; % RPG D
            SolverParams.RPGVariant = 0;
            SolverParams.LengthW = LengthW;
        case 2
            SolverParams.method = 'RPG'; % RPG
            SolverParams.RPGVariant = 0;
            SolverParams.LengthW = 1;
        case 3
            SolverParams.method = 'RPG'; % RPG D ada
            SolverParams.RPGVariant = 1;
            SolverParams.LengthW = LengthW;
        case 4
            SolverParams.method = 'RPG'; % RPG ada
            SolverParams.RPGVariant = 1;
            SolverParams.LengthW = 1;
        case 5
            SolverParams.method = 'ARPG'; % ARPG D
            SolverParams.RPGVariant = 0;
            SolverParams.LengthW = LengthW;
%             SolverParams.SGIterGap = inf;
        case 6
            SolverParams.method = 'ARPG'; % ARPG
            SolverParams.RPGVariant = 0;
            SolverParams.LengthW = 1;
%             SolverParams.SGIterGap = 100000;
    end

    SolverParams.IsCheckParams = 1;
%     SolverParams.RPGVariant = 0; %0: RPG without adaptive stepsize, 1: RPG with adaptive stepsize
    SolverParams.OutputGap = 20;
    SolverParams.Max_Iteration = maxiter;
    SolverParams.DEBUG = 1;
    SolverParams.Tolerance = tol;
    [xopt, fs, Ds, gfgf0, iter, nf, ng, nR, nV, nVp, nH, comtime, fsall, Dsall, times] = ...
        TestStieSPCA(A, lambda, Xinitial, SolverParams);
    
    xopt.main(abs(xopt.main) < 1e-5) = 0;
    sparsity = sum(sum(abs(xopt.main) < 1e-5)) / (n * p);
    xopt = reshape(xopt.main, n, p);
    % adjusted variance
    [Q, R] = qr(A * xopt, 0);
    avar = trace(R * R);
end

function str = outputfloat(x)
    if(x <= 0)
        sn = '-';
        x = abs(x);
    else
        sn = '';
    end
    p = log(x)/log(10);
    p = - ceil(-p);
    x = round(x * 10^(-p) * 100);
    x = x / 100;
    strx = sprintf('%3.2f', x);
    if(p ~= 0)
        str = [sn strx '_{' num2str(p) '}'];
    else
        str = [sn strx];
    end
end
