/*
This is the global head file. Every file in ROPTLIB will include this file.

---- WH
*/

#ifndef DEF_H
#define DEF_H

//#define MATLAB_MEX_FILE//For debug---
//#define DRIVERJULIAPROB//For debug---

//#define ROPTLIB_WITH_FFTW
/* 
If all the test files are included in a project, then only uncomment one of them to specify which test problem is run.
*/

//#define TESTEUCFRECHETMEAN
//#define TESTEUCQUADRATIC
//#define TESTPRODUCT
//#define TESTSPHERERAYQUO
//#define TESTSTIEBROCKETT
//#define TESTSTIESPARSEBROCKETT 
//#define TESTGRASSRQ
//#define TESTCSO
//#define TESTSTIESOFTICA
//#define TESTSPARSEPCA
//#define TESTTESTSPARSEPCA
//#define TESTWEIGHTEDLOWRANK
//#define TESTELASTICCURVESRO
//#define TESTMYMATRIX
//#define TESTSPDMEAN
//#define TESTPRESHAPEPATHSTRAIGHTEN
//#define TESTSHAPEPATHSTRAIGHTEN
//#define TESTSPDTENSORDL
//#define TESTEUCPOSSPCD
//#define TESTORTHBOUNDINGBOX
//#define TESTKARCHERMEAN
//#define TESTLRMATRIXCOMPLETION
//#define TESTLRBLINDDECONVOLUTION
//#define TESTEUCBLINDDECONVOLUTION
//#define TESTCFR2BLINDDECONVOLUTION
//#define TESTCFR2BLINDDECON2D
//#define TESTCFR2BLINDDECON3D
//#define TESTCSOPHASERETRIEVAL
//#define TESTSPHERESPARSESTVECTOR

//#define TESTSIMPLEEXAMPLE
//#define TESTPRODUCTEXAMPLE

#include <cmath>

/*std library*/
#include <cstdio>
#include <cstdlib>

/*For obtaining the lower bound, upper bound of numbers of realdp precision*/
#include <climits>
#include <limits>

//#define realdp float
//#define realdpcomplex complex
#define realdp double
#define realdpcomplex doublecomplex

#ifndef MATLAB_MEX_FILE
#include <f2c.h>
#endif // end of ifndef MATLAB_MEX_FILE

#ifdef _WIN64 // The following code is compiled only when this library is compiled in Windows (64-bit only)
	/*If the code is compile under DEBUG mode, then test wheter there is memory leakage or not*/
	#ifdef _DEBUG
	#define DEBUG_CLIENTBLOCK   new( _CLIENT_BLOCK, __FILE__, __LINE__)
	/*Use my code to help checking memory leakage. One has to define a global variable:
		std::map<integer *, integer> *CheckMemoryDeleted;
	before running the code.
	*/
	//#define CHECKMEMORYDELETED
	#else
	#define DEBUG_CLIENTBLOCK
	#endif

/*This is used for checking the memory leakage in windows system*/
#define _CRTDBG_MAP_ALLOC
#include <crtdbg.h>

/*This is used for checking the memory leakage in windows system if the code is run in DEBUG mode*/
#ifdef _DEBUG
#define new DEBUG_CLIENTBLOCK
#endif

#elif _WIN32 // The following code is compiled only when this library is compiled in Windows (both 32-bit and 64-bit only)
   //define something for Windows (32-bit and 64-bit, this part is common)
#elif __APPLE__ // The following code is compiled only when this library is compiled in MAC
    #include "TargetConditionals.h"
    #if TARGET_IPHONE_SIMULATOR
         // iOS Simulator
    #elif TARGET_OS_IPHONE
        // iOS device
    #elif TARGET_OS_MAC
        // Other kinds of Mac OS
    #else
        // Unsupported platform
    #endif
#elif __linux// The following code is compiled only when this library is compiled in Linux system
    // linux
	#ifdef __GNUC__
/*
		const class {
		public:
			template<class T> // convertible to any type
			operator T*(void) const // of null non-member
			{
				return 0;
			} // pointer...
			template<class C, class T> // or any type of null
			operator T C::*(void) const // member pointer...
			{
				return 0;
			}
		private:
			void operator&(void) const; // whose address can't be taken
		} nullptr = {};
*/
	#endif // end of __GNUC__
#elif __unix // all unices not caught above
    // Unix
#elif __posix
    // POSIX
#endif // end of checking platforms

#include "Others/BlasLapackCppWrapper.h"

/*Help to debug the code*/
#include "Others/ForDebug.h"

/*For obtain the computational time*/
#include "Others/Timer.h"

#include <map>
#include <string>

typedef std::map<std::string, realdp> PARAMSMAP;

/*Define the number PI*/
#define PI 3.14159265358979323846264

#endif // end of DEF_H
