/*
This file defines the class for the problem 
min_x c^T x + L x^T A x
such that x \in Multinomial manifold

Problem --> MNCRModel

---- WH
*/

#ifndef MNCRMODEL_H
#define MNCRMODEL_H

#include "Manifolds/Multinomial/Multinomial.h"
#include "Manifolds/Multinomial/MNVariable.h"
#include "Manifolds/Multinomial/MNVector.h"
#include "Problems/Problem.h"
#include "Others/def.h"

/*Define the namespace*/
namespace ROPTLIB{

	class MNCRModel : public Problem{
	public:
		MNCRModel(realdp *c, realdp *A, realdp L, integer m);
		virtual ~MNCRModel();
		virtual realdp f(Variable *x) const;
		virtual void EucGrad(Variable *x, Vector *gf) const;
		virtual void EucHessianEta(Variable *x, Vector *etax, Vector *xix) const;

		realdp *c;    /* linear term */
		realdp *A;    /* quadratic term */
		realdp L;     /* constant*/
		mutable integer m;
	};
}; /*end of ROPTLIB namespace*/
#endif
