/*
This file defines the class for the nearest correlation matrix problem 
\min_{diag(X^T X + y^T y) = I_r} 0.5 \|A - X^T X - diag(y^T y)\|_F^2
where A \in R^{num \times num}, [X; y] \in OB(n, num) / O_{n-1}, X \in R^{(n-1) \times num}, y \in R^{1 \times num}.


Problem --> ObliqueQCor

---- WH
*/

#ifndef OBLIQUEQCOR_H
#define OBLIQUEQCOR_H


#include "Manifolds/ObliqueQ/ObliqueQ.h"
#include "Manifolds/ObliqueQ/ObliqueQVariable.h"
#include "Manifolds/ObliqueQ/ObliqueQVector.h"
#include "Problems/Problem.h"
#include "Manifolds/SharedSpace.h"
#include "Others/def.h"

/*Define the namespace*/
namespace ROPTLIB{

	class ObliqueQCor : public Problem{
	public:
		ObliqueQCor(realdp *inA, integer inn, integer innum);
		virtual ~ObliqueQCor();
		virtual realdp f(Variable *x) const;

		virtual void EucGrad(Variable *x, Vector *egf) const;
		virtual void EucHessianEta(Variable *x, Vector *etax, Vector *exix) const;

		realdp *A;
		mutable integer n;
		mutable integer num;
		realdp C;
	};

}; /*end of ROPTLIB namespace*/

#endif // end of OBLIQUEQCOR_H