/*
This is the test file to run the problem defined in MNCRModel.h and MNCRModel.cpp.

---- WH
*/

#ifndef TESTMNCRMODEL_H
#define TESTMNCRMODEL_H


#include <iostream>
#include "Others/randgen.h"
#include "Manifolds/Manifold.h"
#include "Problems/Problem.h"
#include "Solvers/SolversLS.h"
#include <ctime>

/*If this test file is called from Matlab, then functions in DriverMexProb.h are used.*/
#include "test/DriverMexProb.h"

#include "Manifolds/Multinomial/Multinomial.h"
#include "Manifolds/Multinomial/MNVariable.h"
#include "Manifolds/Multinomial/MNVector.h"
#include "Problems/MNCRModel/MNCRModel.h"

#include "Manifolds/Euclidean/EucVariable.h"
#include "Manifolds/Euclidean/EucVector.h"
#include "Problems/EucFrechetMean/EucFrechetMean.h"

#include "Problems/StieBrockett/StieBrockett.h"
#include "Manifolds/Stiefel/StieVector.h"
#include "Manifolds/Stiefel/StieVariable.h"
#include "Manifolds/Stiefel/Stiefel.h"

#include "Solvers/RSD.h"
#include "Solvers/RNewton.h"
#include "Solvers/RCG.h"
#include "Solvers/RBroydenFamily.h"
#include "Solvers/RWRBFGS.h"
#include "Solvers/RBFGS.h"
#include "Solvers/LRBFGS.h"

#include "Solvers/SolversTR.h"
#include "Solvers/RTRSD.h"
#include "Solvers/RTRNewton.h"
#include "Solvers/RTRSR1.h"
#include "Solvers/LRTRSR1.h"

#include "Others/def.h"

using namespace ROPTLIB;

void testMNCRModel(void);
void testMNCRModel(realdp *c, realdp *A, realdp L, integer m, realdp *X = nullptr, realdp *Xopt = nullptr);

#endif // end of TESTMNCRMODEL_H
