#include "test/TestNSOLyapunov.h"

using namespace ROPTLIB;

void testNSOLyapunov(void)
{
	integer n = 5, p = 2, pC = 1;

	/*
	realdp *A = new realdp[n * n];
	realdp *Temp = new realdp[n * n];
	for (integer i = 0; i < n * n; i++)
		Temp[i] = genrandnormal();
	// A = temp * temp^T, details: http://www.netlib.org/lapack/explore-html/d7/d2b/gemm_8f.html
	gemm_(GLOBAL::N, GLOBAL::T, &n, &n, &n, &GLOBAL::DONE, Temp, &n, Temp, &n, &GLOBAL::DZERO, A, &n);
	*/

	//integer nzmaxA = n + 2 * (n - 1);
	//realdp *A = new realdp[n + 2 * (n - 1)];
	//int *inirA = new int[2 * nzmaxA];
	//int *injcA = inirA + nzmaxA;
	//for (integer i = 0; i < n; i++)
	//{
	//	A[i] = 2;
	//	inirA[i] = i;
	//	injcA[i] = i;
	//}
	//for (integer i = 0; i < n - 1; i++)
	//{
	//	A[n + i] = -1;
	//	inirA[n + i] = i;
	//	injcA[n + i] = i + 1;
	//	A[2 * n - 1 + i] = -1;
	//	inirA[2 * n - 1 + i] = i + 1;
	//	injcA[2 * n - 1 + i] = i;
	//}

	realdp *A = new realdp[n * n];
	for (integer i = 0; i < n * n; i++)
		A[i] = 0;
	for (integer i = 0; i < n; i++)
		A[i + i * n] = 2;
	for (integer i = 0; i < n - 1; i++)
	{
		A[i + (i + 1) * n] = -1;
		A[i + 1 + i * n] = -1;
	}

	realdp *M = new realdp[n * n];
	for (integer i = 0; i < n * n; i++)
		M[i] = 0;
	for (integer i = 0; i < n; i++)
		M[i + i * n] = 1;
	//for (integer i = 0; i < n * n; i++)
	//	Temp[i] = genrandnormal();
	//// M = temp * temp^T, details: http://www.netlib.org/lapack/explore-html/d7/d2b/gemm_8f.html
	//gemm_(GLOBAL::N, GLOBAL::T, &n, &n, &n, &GLOBAL::DONE, Temp, &n, Temp, &n, &GLOBAL::DZERO, M, &n);

	realdp *C = new realdp[n * pC];
	for (integer i = 0; i < pC * n; i++)
		C[i] = genrandnormal();
	// C = temp * temp^T, details: http://www.netlib.org/lapack/explore-html/d7/d2b/gemm_8f.html
//	gemm_(GLOBAL::N, GLOBAL::T, &n, &n, &GLOBAL::IONE, &GLOBAL::DONE, Temp, &n, Temp, &n, &GLOBAL::DZERO, C, &n);

	//delete[] Temp;

	NSOVariable SCOX(n, p);

	SCOX.RandInManifold();

	// Define the manifold
	NStQOrth Domain(n, p);
	//Domain.SetHasHHR(true);

	Domain.ChooseNSOParamsSet2();

	Domain.CheckParams();

	//Domain.CheckIntrExtr(&SCOX);
	//Domain.CheckRetraction(&SCOX); // note that the representation is not unique, so this may not yeild a correct result.
	//Domain.CheckDiffRetraction(&SCOX);
	//Domain.CheckIsometryofVectorTransport(&SCOX);
	//Domain.CheckIsometryofInvVectorTransport(&SCOX);
	//Domain.CheckLockingCondition(&SCOX);
	//Domain.CheckcoTangentVector(&SCOX);
	//Domain.CheckVecTranComposeInverseVecTran(&SCOX);
	//Domain.CheckTranHInvTran(&SCOX);
	//Domain.CheckHaddScaledRank1OPE(&SCOX);

	//NSOLyapunov Prob(A, nzmaxA, inirA, injcA, true, M, 0, nullptr, nullptr, false, C, pC, n, p);
	NSOLyapunov Prob(A, 0, nullptr, nullptr, false, M, 0, nullptr, nullptr, false, C, pC, n, p);

	/*The domain of the problem is a Stiefel manifold*/
	Prob.SetDomain(&Domain);

	//Prob.CheckGradHessian(&SCOX);

	LRBFGS *LRBFGSsolver = new LRBFGS(&Prob, &SCOX);
	LRBFGSsolver->Debug = ITERRESULT; //ITERRESULT;// 
	LRBFGSsolver->Max_Iteration = 100;
	LRBFGSsolver->Tolerance = static_cast<realdp> (1e-10);
	LRBFGSsolver->OutputGap = 1;
	LRBFGSsolver->InitSteptype = ONESTEP;
	LRBFGSsolver->LengthSY = 0;
	LRBFGSsolver->CheckParams();
	LRBFGSsolver->Accuracy = static_cast<realdp> (1e-10);
	LRBFGSsolver->Finalstepsize = 1;
	LRBFGSsolver->BBratio = -1;
	LRBFGSsolver->Run();

	//Prob.CheckGradHessian(LRBFGSsolver->GetXopt());

	//LRBFGSsolver->GetSolverTMP()->Print("Tmp", false);

	delete LRBFGSsolver;


	//RTRNewton *RTRNewtonsolver = new RTRNewton(&Prob, &SCOX);
	//RTRNewtonsolver->Debug = ITERRESULT; //ITERRESULT;// 
	//RTRNewtonsolver->Max_Iteration = 4000;
	//RTRNewtonsolver->Tolerance = 1e-7;
	//RTRNewtonsolver->OutputGap = 1;
	//RTRNewtonsolver->Run();

	//delete RTRNewtonsolver;

	//RCG *RCGsolver = new RCG(&Prob, &SCOX);
	//RCGsolver->Debug = ITERRESULT; //ITERRESULT;// 
	//RCGsolver->Max_Iteration = 4000;
	//RCGsolver->Tolerance = 1e-7;
	//RCGsolver->OutputGap = 100;
	//RCGsolver->Run();

	//delete RCGsolver;

	delete[] A;
	delete[] M;
	delete[] C;
}


#ifdef MATLAB_MEX_FILE

std::map<integer *, integer> *CheckMemoryDeleted;

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
	if (nrhs < 7)
	{
		mexErrMsgTxt("The number of arguments should be at least seven.\n");
	}
	realdp *A, *M, *C, *X;
	A = mxGetPr(prhs[0]);
	M = mxGetPr(prhs[1]);
	C = mxGetPr(prhs[2]);
	X = mxGetPr(prhs[3]);
	/* dimensions of input matrices */
	integer n, p, pC, HasHHR, metric;
	n = mxGetM(prhs[0]);
	p = mxGetN(prhs[3]);
	pC = mxGetN(prhs[2]);
	if (mxGetN(prhs[0]) != n || mxGetM(prhs[1]) != n || mxGetN(prhs[1]) != n || mxGetM(prhs[2]) != n || mxGetM(prhs[3]) != n)
	{
		mexErrMsgTxt("The size of A or the size of M or the size of C or the size of X is not correct.\n");
	}
	HasHHR = static_cast<integer> (mxGetScalar(prhs[4]));
	metric = static_cast<integer> (mxGetScalar(prhs[5]));

	bool isAsparse = mxIsSparse(prhs[0]);
	integer nzmaxA;
	size_t *irA = nullptr, *jcA = nullptr;
	int *inirA = nullptr, *injcA = nullptr;
	if (isAsparse)
	{
		nzmaxA = mxGetNzmax(prhs[0]);
		irA = mxGetIr(prhs[0]);
		jcA = mxGetJc(prhs[0]);

		inirA = new int[2 * nzmaxA];
		injcA = inirA + nzmaxA;
		for (integer i = 0; i < n; i++)
		{
			for (unsigned long long j = jcA[i]; j < jcA[i + 1]; j++)
			{
				/*row: ir[j], column: i, entry: A[j]*/
				inirA[j] = irA[j];
				injcA[j] = i;
			}
		}

//		for (integer i = 0; i < nzmaxA; i++)
//		{
//			printf("%d, %d, %e\n", inirA[i], injcA[i], A[i]);
//		}
	}
	bool isMsparse = mxIsSparse(prhs[1]);
	integer nzmaxM;
	size_t *irM = nullptr, *jcM = nullptr;
	int *inirM = nullptr, *injcM = nullptr;
	if (isMsparse)
	{
		nzmaxM = mxGetNzmax(prhs[1]);
		irM = mxGetIr(prhs[1]);
		jcM = mxGetJc(prhs[1]);

		inirM = new int[2 * nzmaxM];
		injcM = inirM + nzmaxM;
		for (integer i = 0; i < n; i++)
		{
			for (unsigned long long j = jcM[i]; j < jcM[i + 1]; j++)
			{
				/*row: ir[j], column: i, entry: M[j]*/
				inirM[j] = irM[j];
				injcM[j] = i;
			}
		}
//		for (integer i = 0; i < nzmaxM; i++)
//		{
//			printf("%d, %d, %e\n", inirM[i], injcM[i], M[i]);
//		}
	}
	genrandseed(0);
	CheckMemoryDeleted = new std::map<integer *, integer>;

	// Obtain an initial iterate
	NSOVariable NSOX(n, p);
	realdp *NSOXptr = NSOX.ObtainWriteEntireData();
	for (integer i = 0; i < n * p; i++)
		NSOXptr[i] = X[i];

	NSOVariable *NSOsoln = nullptr;
	if (nrhs >= 8)
	{
		realdp *soln = mxGetPr(prhs[7]); /*soln: n by p*/
		NSOsoln = new NSOVariable(n, p);
		realdp *NSOsolnptr = NSOsoln->ObtainWriteEntireData();
		for (integer i = 0; i < n * p; i++)
		{
			NSOsolnptr[i] = soln[i];
		}
	}

	// Define the manifold
	NStQOrth Domain(n, p);

	// Define the matrix completion problem
	NSOLyapunov Prob(A, nzmaxA, inirA, injcA, isAsparse, M, nzmaxM, inirM, injcM, isMsparse, C, pC, n, p);
	Prob.SetDomain(&Domain);

	Domain.SetHasHHR(HasHHR != 0);
	if (metric == 1)
		Domain.ChooseNSOParamsSet1();
	if (metric == 2)
		Domain.ChooseNSOParamsSet2();
	if (metric == 3)
		Domain.ChooseNSOParamsSet3();
	if (metric == 4)
		Domain.ChooseNSOParamsSet4();
	if (metric == 5)
		Domain.ChooseNSOParamsSet5();
	if (metric == 6)
		Domain.ChooseNSOParamsSet6();
	//Domain.CheckParams();

	// Call the function defined in DriverMexProb.h
	ParseSolverParamsAndOptimizing(prhs[6], &Prob, &NSOX, NSOsoln, plhs);

	std::map<integer *, integer>::iterator iter = CheckMemoryDeleted->begin();
	for (iter = CheckMemoryDeleted->begin(); iter != CheckMemoryDeleted->end(); iter++)
	{
		if (iter->second != 1)
			printf("Global address: %p, sharedtimes: %d\n", iter->first, iter->second);
	}
	delete CheckMemoryDeleted;
	delete NSOsoln;
	delete[] inirA;
	delete[] inirM;

	return;
}

#endif
