/*
This is the test file for the Geometric mean of SPD problem defined in SPDMean.h and SPDMean.cpp.

---- WH
*/

#ifndef TESTSPDMEANMAJORIZATION_H
#define TESTSPDMEANMAJORIZATION_H

/*Help to debug the code*/
#include "Others/ForDebug.h"

/*Output to console*/
#include <iostream>

/*Computational time*/
#include <ctime>
#include "Others/Timer.h"

/*The global head file*/
#include "Others/def.h"
#include "Others/MyMatrix.h"
#include "Problems/SPDMean/SPDMean.h"
#include "Solvers/SolversLS.h"

using namespace ROPTLIB;

#if !defined(MATLAB_MEX_FILE) && defined(TESTSPDMEANRSD)
int main(void);
#endif

/*The main test function*/
void testSPDMeanMajorization(void);
void MajMinAlgo(realdp *Ls, integer n, integer num, realdp *initX, integer maxiter, realdp tol, 
	            integer Debug, realdp *Xout, realdp *timeSeries, realdp *distSeries, integer &totaliter, realdp &ComTime, realdp *Xtrue = nullptr);
void Computef1Xf2XXinvgX(realdp *Ls, integer n, integer num, realdp *x, realdp *XinvgX, realdp *f1X, realdp *f2X);

#endif 
